program mpdreiusb;

uses sysutils,classes,fileutil;

var
  debug                : boolean;
  zieldatei            : integer;
  dateilaenge          : integer;
  destdir,sourcedir    : string;

function namentest(name:string):string;
var
  realname        : string;
  code            : integer;
  i               : integer;
begin
  realname:='';
  for i := 0 to length(name)-2 do
  begin
    code:=ord(name[i]);
    if ((code >47) and (code < 58)) then realname :=realname+name[i]
  end;
  if not(length(realname) =dateilaenge) then
    namentest := '0'
  else
    namentest :=realname;
end;


function nametointeger(name:string):integer;
var
   realname:string;
begin
   realname:=namentest(name);
   if debug=true then writeln(realname);
   nametointeger:=strtoint(realname);
end;

function integertoname(zahl:integer):string;
var
   realname:string;
begin
   realname:=inttostr(zahl);
   while (length(realname)<dateilaenge) do
   begin
     realname := '0'+realname;
   end;
   realname := realname+'.mp3';
   if debug=true then writeln(realname);
   integertoname:=realname;
end;


function maxdateiinordner(pfad:string):integer;
var
  groesstedatei      : integer;
  SR                 : TSearchRec;
begin
  groesstedatei := 0;
  if FindFirst(pfad + '*.mp3', faAnyFile and not faDirectory, SR) = 0 then try
    repeat

      if debug=true then writeln(SR.name);
      if groesstedatei < nametointeger(Sr.name) then groesstedatei := nametointeger(Sr.name);
    until not(FindNext(SR) = 0);
  finally
    FindClose(SR);
  end;
  maxdateiinordner:=groesstedatei;
end;


procedure copyfiles(start:integer;source:string;dest:string);
var
    SR                 : TSearchRec;
begin
  if debug=true then writeln('Kopierquelle: ' +source);
  if FindFirst(source + '*.mp3', faAnyFile and not faDirectory, SR) = 0 then try
    repeat
      start := start+1;
      if debug=true then writeln(source+SR.name+' -> '+dest+integertoname(start));
      copyfile(source+SR.name,dest+integertoname(start));

    until not(FindNext(SR) = 0);
  finally
    FindClose(SR);
  end;

end;


begin
  WriteLn('Program: ', ParamStr(0));
  if  ParamCount = 2 then
  begin

    debug        := true;

    destdir      := ParamStr(2);
    sourcedir    := ParamStr(1);

    if not(copy(sourcedir,length(sourcedir),1)='\') then sourcedir := sourcedir+'\';
    if not(copy(destdir,length(destdir),1)='\') then destdir := destdir+'\';
    if debug=true then writeln('Source: '+sourcedir);
    if debug=true then writeln('Destination: '+destdir);

    dateilaenge  := 5;

    zieldatei    := maxdateiinordner(destdir);

    if debug=true then writeln(integertoname(zieldatei));

    copyfiles(zieldatei,sourcedir,destdir);
  end
  else
  begin
    writeln('Fehler in den Parametern');
    readln();
  end;
end.

